import { createApp } from "vue";
import App from "./App.vue";

(() => {
  //创建样式隔离的容器 避免和 当前浏览器页面的css 命名相同导致样式出现问题
  const rootIdName = "crx_down";
  const beforeRoot = document.querySelector(`#${rootIdName}`);
  if (beforeRoot) {
    document.body.removeChild(beforeRoot);
  }
  const container = document.createElement("div");
  container.id = rootIdName;
  const root = document.createElement("div");
  const styleEl = document.createElement("link");
  const shadowDOM = container.attachShadow({ mode: "open" }) || container;
  styleEl.setAttribute("rel", "stylesheet");
  let url = chrome.runtime.getURL("css/chunk-vendors.css");

  styleEl.setAttribute("href", url);
  shadowDOM.appendChild(styleEl);
  shadowDOM.appendChild(root);
  document.body.appendChild(container);

  const app = createApp(App);
  app.mount(root);
})();
